extends Position2D

const Meteoro1 = preload("res://Meteoro1.tscn")
const Meteoro2 = preload("res://Meteoro1.tscn")
const Meteoro3 = preload("res://Meteoro3.tscn")
const Meteoro4 = preload("res://Meteoro4.tscn")
const Nave1 = preload("res://Nave1.tscn")
const Nave2 = preload("res://Nave1.tscn")
const Nave3 = preload("res://Nave3.tscn")
const Nave4 = preload("res://Nave4.tscn")

var meteoros = {1: Meteoro1.instance(), 2: Meteoro2.instance(), 3: Meteoro3.instance(), 4: Meteoro4.instance()}

var intervalo = 0
var rng = RandomNumberGenerator.new()
var produciendo = false
export(Vector2) var destino = null
var tipo_historico = []
var tiempo_actual = 0
var b

enum tipo {
	METEOROS,
	NAVES
}

func _ready():
	if destino == null:
		produciendo = false
	rng.randomize()
	intervalo = rng.randf_range(1, 3)
	cambiar_tipo(tipo.METEOROS)

func cambiar_tipo(valor):
	tipo_historico.append(valor)

func tipo_actual():
	return tipo_historico.back()

func _physics_process(delta):
	if produciendo and tiempo_actual <= 0:
		tiempo_actual = intervalo
		if tipo_actual() == tipo.METEOROS:
			crear_meteoro()
		if tipo_actual() == tipo.NAVES:
			crear_nave()
	else:
		tiempo_actual -= delta

func crear_meteoro():
	if rng.randi_range(1, 100) >= 75:
		var m = rng.randi_range(1, 4)
		if m == 1:
			b = Meteoro1.instance()
		elif m == 2:
			b = Meteoro2.instance()
		elif m == 3:
			b = Meteoro3.instance()
		elif m == 4:
			b = Meteoro4.instance()
		
		get_parent().add_child(b)
		b.destino = destino
		b.rotando = true if rng.randi_range(0, 1) == 1 else false
		b.position = position

func crear_nave():
	if rng.randi_range(1, 100) >= 75:
		var m = rng.randi_range(1, 4)
		if m == 1:
			b = Nave1.instance()
		elif m == 2:
			b = Nave2.instance()
		elif m == 3:
			b = Nave3.instance()
		elif m == 4:
			b = Nave4.instance()
		
		get_parent().add_child(b)
		b.destino = destino
		b.position = position

func produzco_naves():
	cambiar_tipo(tipo.NAVES)

func produzco_meteoros():
	cambiar_tipo(tipo.METEOROS)

func producir(valor):
	produciendo = valor
