extends KinematicBody2D

const Laser = preload("res://Laser.tscn")
const Explosion = preload("res://Explosion.tscn")

var destino = null
var velocidad
var b

var rng = RandomNumberGenerator.new()

func _ready():
	rng.randomize()
	velocidad = rng.randi_range(20, 100)
	var escala = rng.randf_range(0.4, 0.7)
	scale = Vector2(escala, escala)
	add_to_group("naves")

func _physics_process(_delta):
	if destino != null and  position.distance_to(destino) > 5:
		var _velocidad_movimiento = move_and_slide(position.direction_to(destino) * velocidad)
		if rng.randi_range(1, 100) > 99:
			b = Laser.instance()
			get_parent().add_child(b)
			b.transform = $Disparo.global_transform
	else:
		queue_free()

func crear_explosion():
	b = Explosion.instance()
	get_parent().add_child(b)
	b.get_node("Sprite").transform = global_transform
	queue_free()
