extends KinematicBody2D

const Lander = preload("res://Lander.tscn")
onready var pos_izquierda = get_parent().get_node("IzquierdaNaveNodriza").position
onready var pos_derecha = get_parent().get_node("DerechaNaveNodriza").position
onready var destino = pos_izquierda
var velocidad = 100
var b
var estado_historico = []
var descendiendo = true

signal cambiar_estado(nuevo_estado)
signal lander_fuera
signal eliminar_lander
signal lander_falso

enum estado {
	MOVIMIENTO,
	SOLTANDO,
	CAPTURANDO
}

func _ready():
	position =  pos_izquierda
	var _sce = self.connect("cambiar_estado", self, "cambiar_estado")
	var _clf = self.connect("lander_falso", get_parent(), "comenzar_atraque")
	emit_signal("cambiar_estado", estado.MOVIMIENTO)

func cambiar_estado(estado):
	estado_historico.append(estado)

func estado_actual():
	return estado_historico.back()

func _physics_process(_delta):
	match estado_actual():
		estado.MOVIMIENTO:
			if position.distance_to(destino) > 5:
				var _velocidad_movimiento = move_and_slide(position.direction_to(destino) * velocidad)
			else:
				cambiar_destino()

func cambiar_destino():
	if position.distance_to(pos_izquierda) < 5:
		destino = pos_derecha
	else:
		destino = pos_izquierda

func soltar_lander():
	emit_signal("cambiar_estado", estado.SOLTANDO)
	$Soltar.start()

func _on_Soltar_timeout():
	b = Lander.instance()
	get_parent().add_child(b)
	b.position = Vector2(position.x, position.y + 15)

func _on_AreaCarga_body_exited(_body):
	if estado_actual() == estado.SOLTANDO:
		var _lcl = self.connect("lander_fuera", b, "lander_puede_maniobrar")
		emit_signal("lander_fuera")
		emit_signal("cambiar_estado", estado.MOVIMIENTO)
		#$AreaCarga/CollisionShape2D.set_deferred("disabled", true)

func recibir_lander():
	$AreaCarga/CollisionShape2D.set_deferred("disabled", false)

func lander_descendiendo(valor):
	descendiendo = valor

func _on_AreaCarga_body_entered(_body):
	if descendiendo == false:
		var _bcl = self.connect("eliminar_lander", b, "remover_lander")
		emit_signal("cambiar_estado", estado.CAPTURANDO)
		emit_signal("eliminar_lander")
		emit_signal("lander_falso")

func mover():
	emit_signal("cambiar_estado", estado.MOVIMIENTO)
