extends Node

const Astronauta = preload("res://Astronauta.tscn")
var por_rescatar = 5
var rescatados = 0
#var nuevo_lander = true
var vidas = 3

signal soltar_lander
signal lander_asciende
signal astro_por_rescatar(cant)
signal astro_rescatados(cant)
signal astro_en_camino
signal lander_descendiendo(valor)
signal atracar(posicion1, posicion2)
signal nave_nodriza_mover
signal vidas_restantes(cant)
signal producir(valor)
signal producir_naves
signal producir_meteoros

func _ready():
	var _sll = self.connect("soltar_lander", $NaveNodriza, "soltar_lander")
	var _aec = self.connect("astro_en_camino", $NaveNodriza, "recibir_lander")
	var _apr = self.connect("astro_por_rescatar", $HUD, "por_rescatar")
	var _are = self.connect("astro_rescatados", $HUD, "rescatados")
	var _vre = self.connect("vidas_restantes", $HUD, "vidas")
	var _lde = self.connect("lander_descendiendo", $NaveNodriza, "lander_descendiendo")
	var _nnm = self.connect("nave_nodriza_mover", $NaveNodriza, "mover")
	var _atr = self.connect("atracar", $LanderFalso, "comenzar_atraque")
	for generador in get_tree().get_nodes_in_group("generador"):
		connect("producir", generador, "producir")
		connect("producir_naves", generador, "produzco_naves")
		connect("producir_meteoros", generador, "produzco_meteoros")
	emit_signal("astro_por_rescatar", por_rescatar)
	emit_signal("astro_rescatados", rescatados)
	emit_signal("vidas_restantes", vidas)
	emit_signal("producir", true)
	emit_signal("producir_meteoros")

func _unhandled_input(event):
	if vidas > 0 and get_node_or_null("Lander") == null and event.is_action_pressed("ui_down"):
		emit_signal("soltar_lander")
		#nuevo_lander = false

func lander_aterrizado():
	emit_signal("producir_naves")
	for e in get_children():
		if e.is_in_group("meteoros"):
			e.queue_free()

func lander_abordar():
	if por_rescatar > 0:
		var b = Astronauta.instance()
		b.position = $DerechaAstronautas.position
		b.direccion = "derecha"
		b.destino = $PlataformaDespegue.position
		add_child(b)

func astronauta_ha_abordado():
	var _las = self.connect("lander_asciende", $Lander, "lander_ascendiendo")
	emit_signal("lander_asciende")
	por_rescatar -= 1
	emit_signal("astro_por_rescatar", por_rescatar)
	emit_signal("astro_en_camino")
	emit_signal("lander_descendiendo", false)
	Physics2DServer.area_set_param(get_viewport().find_world_2d().get_space(),Physics2DServer.AREA_PARAM_GRAVITY_VECTOR, Vector2(0, -1))

func lander_destruido():
	vidas -= 1
	emit_signal("vidas_restantes", vidas)
	if vidas > 0:
		nuevo_lander()

func nuevo_lander():
	emit_signal("producir_meteoros")
	emit_signal("nave_nodriza_mover")
	emit_signal("lander_descendiendo", true)
	for e in get_children():
		if e.is_in_group("naves"):
			e.queue_free()
	Physics2DServer.area_set_param(get_viewport().find_world_2d().get_space(),Physics2DServer.AREA_PARAM_GRAVITY_VECTOR, Vector2(0, 1))

func comenzar_atraque():
	emit_signal("producir_meteoros")
	for e in get_children():
		if e.is_in_group("naves"):
			e.queue_free()
	$LanderFalso.position = $Lander.position
	$LanderFalso.show()
	emit_signal("atracar", Vector2($NaveNodriza.position.x, $NaveNodriza.position.y + 50), Vector2($NaveNodriza.position.x, $NaveNodriza.position.y))

func desembarcar_astronauta():
	$NuevoLander.start()

func _on_NuevoLander_timeout():
	rescatados += 1
	emit_signal("astro_rescatados", rescatados)
	nuevo_lander()
